#import "MentsukeController.h"
#import "Mentsuker.h"

@implementation MentsukeController

- (IBAction)startConvertion:(id)sender
{
   if(![openButton isEnabled])
      return;
   
   [openButton setEnabled:NO];
   
   NSArray *fileTypes=[NSArray arrayWithObject:@"pdf"];
   NSOpenPanel *oPanel=[NSOpenPanel openPanel];
   [oPanel setAllowsMultipleSelection:YES];
   [oPanel setMessage:NSLocalizedStringFromTable(@"ChooseFiles",
                                                 @"Messages",
                                                 @"")];
   [oPanel beginSheetForDirectory:nil 
                             file:nil 
                            types:fileTypes
                   modalForWindow:mainWindow 
                    modalDelegate:self
                   didEndSelector:@selector(openFileDidEnd: 
                                            returnCode: 
                                            contextInfo:)
                      contextInfo:nil];
}

-(void)openFileDidEnd:(NSOpenPanel*)sheet returnCode:(int)buttonPressed
          contextInfo:(void *)cInfo
{
   if(buttonPressed!=NSOKButton)
    {
      [openButton setEnabled:YES];
      return;
    }
   
   openFiles=[[NSArray alloc] initWithArray:[sheet filenames]];
   
   [sheet close];
   // Then move on to the save panel.
   [self convertWithFilesOpened];
}

-(void)convertWithFilesOpened
{
   NSOpenPanel *sPanel=[NSOpenPanel openPanel];
   [sPanel setCanChooseFiles:NO];
   [sPanel setCanChooseDirectories:YES];
   [sPanel setCanCreateDirectories:YES];
   [sPanel setMessage:NSLocalizedStringFromTable(@"ChooseDir",
                                                 @"Messages",
                                                 @"")];
   [sPanel beginSheetForDirectory:nil 
                             file:nil 
                            types:nil
                   modalForWindow:mainWindow 
                    modalDelegate:self
                   didEndSelector:@selector(chooseDirDidEnd: 
                                            returnCode: 
                                            contextInfo:)
                      contextInfo:nil];
}

-(void)chooseDirDidEnd:(NSOpenPanel*)sheet returnCode:(int)buttonPressed
          contextInfo:(void *)cInfo
{
   if(buttonPressed!=NSOKButton) 
    {
      [openButton setEnabled:YES];
      return;
    }
   
   destDir=[[NSString alloc] initWithString:[sheet filename]];
   
   // Fire off a thread so the progress indicator spins during processing.
   [NSThread detachNewThreadSelector:@selector(convertFiles)
                            toTarget:self withObject:nil];
}

- (void)convertFiles
{
   NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
   
   int i,j=[openFiles count];
   for(i=0;i<j;i++)
    {
      Mentsuker *m=[Mentsuker alloc];
      [m setFile:[openFiles objectAtIndex:i]];
      [statusText setStringValue:NSLocalizedStringFromTable(@"Processing",
                                                            @"Messages",
                                                            @"")];
      [m begin];
      
      [statusText setStringValue:NSLocalizedStringFromTable(@"Saving",
                                                            @"Messages",
                                                            @"")];
      
      [progressBar startAnimation:self];
      NSArray *path=[[openFiles objectAtIndex:i] componentsSeparatedByString:
         @"/"];
      [m writeToFile:[NSString stringWithFormat:@"%@/%@",destDir,[path objectAtIndex:[path count]-1]]];
      [m release];
      [progressBar stopAnimation:self];
      [statusText setStringValue:NSLocalizedStringFromTable(@"Completed",
                                                            @"Messages",
                                                            @"")];
    }
   [openButton setEnabled:YES];
   [openFiles release];
   [destDir release];
   [pool release];
   [NSThread exit];
}

-(BOOL) application : (NSApplication *)theApplication openFiles:(NSArray *) filenames
{
   if(![openButton isEnabled])
      return NO;
   
   [openButton setEnabled:NO];
   openFiles=[[NSArray alloc] initWithArray:filenames];
   [self convertWithFilesOpened];
   return YES;
}
@end
